% -------------------------------------------------------------------------- %
% % ERF function                                                           % %
% % calculates the cumulative probability of standard normal distribution  % %
% -------------------------------------------------------------------------- %

function p = erfp(x)

% x follows normal distribution with mean 0 and standard deviation 1;
if x > 0;
    ax = x;
else
    ax = -x;
end;

if ax <= 7; % normal distribution;
    t = 1 / (1 + .2316419 * ax);
    d = .3989423 * exp(- x * x / 2);
    p = 1 - d * t * ((((1.330274 * t - 1.821256) * t + 1.781478) * t - .3565638) * t + .3193815);
else
    p = 1;
end;

if x < 0;
    p = 1 - p;
end;
