% ----------------------------------------------------------------------- %
% % frand function                                                      % %
% % obtain a random number in the [0 : 1] interval                      % %
% ----------------------------------------------------------------------- %

% possible to be replaced by rand(1, 1) in Matlab; ???
function [rannum, calc] = frand(calc)

calc.seed = 13698763;
calc.m1 = 259200;
calc.a1 = 7141;
calc.c1 = 54773;
calc.m2 = 134456;
calc.a2 = 8121;
calc.c2 = 28411;
calc.m3 = 243000;
calc.a3 = 4561;
calc.c3 = 51349;
calc.rm1 = 1 / calc.m1;
calc.rm2 = 1 / calc.m2;

if calc.randresetflag(calc.obs, 1) == 1;
    calc.randresetflag(calc.obs, 1) = 0;

    calc.randstruct(calc.obs, 1).x1 = mod(calc.c1 + calc.seed, calc.m1);
    calc.randstruct(calc.obs, 1).x1 = mod(calc.a1 * calc.randstruct(calc.obs, 1).x1, calc.m1);

    for k = 1 : calc.randseed(calc.obs, 1) - 1;
        calc.randstruct(calc.obs, 1).x1 = mod(calc.a1 * calc.randstruct(calc.obs, 1).x1, calc.m1);
    end;

    calc.randstruct(calc.obs, 1).x2 = mod(calc.randstruct(calc.obs, 1).x1, calc.m2);
    calc.randstruct(calc.obs, 1).x1 = mod(calc.a1 * calc.randstruct(calc.obs, 1).x1, calc.m1);
    calc.randstruct(calc.obs, 1).x3 = mod(calc.randstruct(calc.obs, 1).x1, calc.m3);

    for k = 1 : 97;
        calc.randstruct(calc.obs, 1).x1 = mod(calc.a1 * calc.randstruct(calc.obs, 1).x1, calc.m1);
        calc.randstruct(calc.obs, 1).x2 = mod(calc.a2 * calc.randstruct(calc.obs, 1).x2, calc.m2);
        calc.randstruct(calc.obs, 1).r(k, 1) = calc.rm1 * (calc.randstruct(calc.obs, 1).x1 + calc.rm2 * calc.randstruct(calc.obs, 1).x2);
    end;
    
else

    calc.randstruct(calc.obs, 1).x1 = calc.randstruct(calc.obs, 1).x1;
    calc.randstruct(calc.obs, 1).x2 = calc.randstruct(calc.obs, 1).x2;
    calc.randstruct(calc.obs, 1).x3 = calc.randstruct(calc.obs, 1).x3;
    
end;

calc.randstruct(calc.obs, 1).x1 = mod(calc.a1 * calc.randstruct(calc.obs, 1).x1 + calc.c1, calc.m1);
calc.randstruct(calc.obs, 1).x2 = mod(calc.a2 * calc.randstruct(calc.obs, 1).x2 + calc.c2, calc.m2);
calc.randstruct(calc.obs, 1).x3 = mod(calc.a3 * calc.randstruct(calc.obs, 1).x3 + calc.c3, calc.m3);

k = floor((97 * calc.randstruct(calc.obs, 1).x3) / calc.m3);

rannum = calc.randstruct(calc.obs, 1).r(k + 1, 1);

calc.randstruct(calc.obs, 1).r(k + 1, 1) = calc.rm1 * (calc.randstruct(calc.obs, 1).x1 + calc.rm2 * calc.randstruct(calc.obs, 1).x2);
calc.randstruct(calc.obs, 1).x1 = calc.randstruct(calc.obs, 1).x1;
calc.randstruct(calc.obs, 1).x2 = calc.randstruct(calc.obs, 1).x2;
calc.randstruct(calc.obs, 1).x3 = calc.randstruct(calc.obs, 1).x3;

 
